diff --git a/src/main/java/net/minecraft/core/block/BlockPlanksPainted.java b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
similarity index 58%
rename from src/main/java/net/minecraft/core/block/BlockPlanksPainted.java
rename to src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
index fe45c35f5..26e5c1cbf 100644
--- a/src/main/java/net/minecraft/core/block/BlockPlanksPainted.java
+++ b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -9,21 +9,17 @@ import net.minecraft.core.world.World;
 // Referenced classes of package net.minecraft.src:
 //            Block, Material
 
-public class BlockPlanksPainted extends Block
+public class PaintedPlanksBlock extends Block
 {
-    public BlockPlanksPainted(String key, int id)
+    public PaintedPlanksBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         return new ItemStack[] { new ItemStack(this, 1, meta) };
     }
 
-    public static int getMetadataForColour(int i)
-    {
-        return ~i & 0xf;
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
new file mode 100644
index 000000000..3865612f6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class PaintedSlabBlock extends SlabBlock
+{
+	public PaintedSlabBlock(Block modelBlock, String namespaceId, int id)
+	{
+		super(modelBlock, namespaceId, id);
+	}
+
+	@Override
+	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+		int meta = mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP ? 2 : 0;
+		world.setBlockMetadataWithNotify(x, y, z, meta | (world.getBlockMetadata(x, y, z) & 0xF0));
+	}
+}
diff --git a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
new file mode 100644
index 000000000..3aaa018c6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class PaintedTrapDoorBlock extends TrapDoorBlock {
+    public PaintedTrapDoorBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material, false);
+    }
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        int meta = world.getBlockMetadata(x, y, z);
+        int colorBits = meta & 0xF0;
+        meta = getMetaForDirection(mob.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+        if(mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP) {
+            meta |= 8;
+        }
+        meta |= colorBits;
+        world.setBlockMetadata(x, y, z, meta);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    {
+        return new ItemStack[] { new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED, 1, (meta >> 4 & 0xF) << 4) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PalmLeavesBlock.java b/src/main/java/net/minecraft/core/block/PalmLeavesBlock.java
new file mode 100644
index 000000000..6738b2313
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PalmLeavesBlock.java
@@ -0,0 +1,16 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class PalmLeavesBlock extends BaseLeavesBlock {
+
+	public PalmLeavesBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.leaves);
+	}
+
+	@Override
+	protected Block getSapling() {
+		return Blocks.SAPLING_PALM;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockFencePaperWall.java b/src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java
similarity index 91%
rename from src/main/java/net/minecraft/core/block/BlockFencePaperWall.java
rename to src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java
index cbed1d345..6998095f4 100644
--- a/src/main/java/net/minecraft/core/block/BlockFencePaperWall.java
+++ b/src/main/java/net/minecraft/core/block/PaperWallFenceBlock.java
@@ -5,11 +5,11 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFencePaperWall extends BlockFenceThin
+public class PaperWallFenceBlock extends ThinFenceBlock
 {
-    public BlockFencePaperWall(String key, int id, Material material)
+    public PaperWallFenceBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesPine.java b/src/main/java/net/minecraft/core/block/PineLeavesBlock.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/BlockLeavesPine.java
rename to src/main/java/net/minecraft/core/block/PineLeavesBlock.java
index 5f4b4eb82..78c0a67c4 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesPine.java
+++ b/src/main/java/net/minecraft/core/block/PineLeavesBlock.java
@@ -1,27 +1,27 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockLeavesBase, Material, ColorizerFoliage, IBlockAccess, 
-//            WorldChunkManager, World, Block, EntityPlayer, 
+//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            WorldChunkManager, World, Block, Player,
 //            ItemStack, Item, ItemShears, StatList, 
 //            Entity
 
-public class BlockLeavesPine extends BlockLeavesBase
+public class PineLeavesBlock extends BaseLeavesBlock
 {
 
-	public BlockLeavesPine(String key, int id)
+	public PineLeavesBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.leaves);
+        super(key, namespaceId, id, Material.leaves);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
 
@@ -35,6 +35,6 @@ public class BlockLeavesPine extends BlockLeavesBase
     @Override
     protected Block getSapling()
     {
-        return Block.saplingPine;
+        return Blocks.SAPLING_PINE;
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockPortal.java b/src/main/java/net/minecraft/core/block/PortalBlock.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockPortal.java
rename to src/main/java/net/minecraft/core/block/PortalBlock.java
index 96b9086b9..85de42374 100644
--- a/src/main/java/net/minecraft/core/block/BlockPortal.java
+++ b/src/main/java/net/minecraft/core/block/PortalBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
@@ -14,17 +14,17 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material, IBlockAccess, World, 
-//            Block, BlockFire, Entity, AxisAlignedBB
+//            Block, FireBlock, Entity, AxisAlignedBB
 
-public class BlockPortal extends BlockTransparent
+public class PortalBlock extends TransparentBlock
 {
 	public int targetDimension;
 	public int portalFrameId;
 	public int portalTriggerId;
 		
-    public BlockPortal(String key, int id, int targetDimension, int portalMaterialId, int portalTriggerId)
+    public PortalBlock(String key, String namespaceId, int id, int targetDimension, int portalMaterialId, int portalTriggerId)
     {
-        super(key, id, Material.portal);
+        super(key, namespaceId, id, Material.portal);
         this.targetDimension = targetDimension;
         this.portalFrameId = portalMaterialId;
         this.portalTriggerId = portalTriggerId;
@@ -61,7 +61,7 @@ public class BlockPortal extends BlockTransparent
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -296,13 +296,13 @@ public class BlockPortal extends BlockTransparent
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         return null;
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
         return 1;
     }
@@ -317,7 +317,7 @@ public class BlockPortal extends BlockTransparent
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         int meta = world.getBlockMetadata(x, y, z);
         if((meta & 0x2) > 0 && rand.nextInt(20) == 0)
diff --git a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/BlockPressurePlate.java
rename to src/main/java/net/minecraft/core/block/PressurePlateBlock.java
index f3f4e851a..69f08f4e4 100644
--- a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
@@ -13,13 +13,13 @@ import net.minecraft.core.util.phys.AABB;
 import java.util.List;
 import java.util.Random;
 
-public class BlockPressurePlate extends Block
+public class PressurePlateBlock extends Block
 {
     private final Class<? extends Entity> triggerMobClass;
 
-	public BlockPressurePlate(String key, int id, Class<? extends Entity> mobType, Material material)
+	public PressurePlateBlock(String key, String namespaceId, int id, Class<? extends Entity> mobType, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         triggerMobClass = mobType;
         setTicking(true);
         float pixel = 1 / 16f;
@@ -27,7 +27,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         return 20;
     }
@@ -45,7 +45,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -98,7 +98,7 @@ public class BlockPressurePlate extends Block
         boolean isCeiling = (meta & 0b10) != 0;
         boolean isSteppedOn = false;
         float f = 0.125F;
-        List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getBoundingBoxFromPool((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
+        List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
         if(list != null && !list.isEmpty())
         {
             isSteppedOn = true;
@@ -121,7 +121,7 @@ public class BlockPressurePlate extends Block
         }
         if(isSteppedOn)
         {
-            world.scheduleBlockUpdate(x, y, z, id, tickRate());
+            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
         }
     }
 
@@ -162,22 +162,20 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
     {
 
         return isPressed(blockAccess.getBlockMetadata(x, y, z));
     }
 
     @Override
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isCeiling = (meta & 0b10) != 0;
-        if(isPressed(world.getBlockMetadata(x, y, z)))
-        {
-            return side == (isCeiling ? 0 : 1);
-        } else
-        {
+        if(isPressed(world.getBlockMetadata(x, y, z))) {
+            return side == (isCeiling ? Side.BOTTOM : Side.TOP);
+        } else {
             return false;
         }
     }
@@ -186,7 +184,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-    public boolean canProvidePower()
+    public boolean isSignalSource()
     {
         return true;
     }
@@ -197,7 +195,7 @@ public class BlockPressurePlate extends Block
         return 1;
     }
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
         if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && sideHeight > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
             world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b10);
         }
diff --git a/src/main/java/net/minecraft/core/block/PumpkinBlock.java b/src/main/java/net/minecraft/core/block/PumpkinBlock.java
new file mode 100644
index 000000000..c0ed759dd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PumpkinBlock.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.block;
+
+// Referenced classes of package net.minecraft.src:
+//            Block, Material, World, Mob,
+//            MathHelper
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tool.SwordToolItem;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class PumpkinBlock extends RotatableBlock
+{
+    private final boolean isCarvable;
+
+	public PumpkinBlock(String key, String namespaceId, int id, boolean isCarvable)
+    {
+        super(key, namespaceId, id, Material.vegetable);
+        setTicking(true);
+        this.isCarvable = isCarvable;
+        withOverrideColor(MaterialColor.paintedOrange);
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
+        if (!isCarvable) return false;
+        ItemStack heldItem = player.getHeldItem();
+        if (heldItem != null && heldItem.getItem() instanceof SwordToolItem){
+            heldItem.damageItem(1,player);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PUMPKIN_CARVED_IDLE.id, player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
+            return true;
+        }
+        return false;
+    }
+
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockPumpkinPie.java b/src/main/java/net/minecraft/core/block/PumpkinPieBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockPumpkinPie.java
rename to src/main/java/net/minecraft/core/block/PumpkinPieBlock.java
index 95e5075e7..a79470794 100644
--- a/src/main/java/net/minecraft/core/block/BlockPumpkinPie.java
+++ b/src/main/java/net/minecraft/core/block/PumpkinPieBlock.java
@@ -1,15 +1,15 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockPumpkinPie extends BlockEdible
+public class PumpkinPieBlock extends EdibleBlock
 {
 
-    public BlockPumpkinPie(String key, int id)
+    public PumpkinPieBlock(String key, String namespaceId, int id)
     {
-        super(key, id, 4, 5, () -> Item.foodPumpkinPie);
+        super(key, namespaceId, id, 4, 5, () -> Items.FOOD_PUMPKIN_PIE);
     }
 
     @Override
@@ -31,7 +31,7 @@ public class BlockPumpkinPie extends BlockEdible
         float xMin = l >= 2 ? 0.5f : f;
         float zMin = l >= 3 ? 0.5f : f;
         float f2 = 0.4375F;
-        return AABB.getBoundingBoxFromPool((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
+        return AABB.getTemporaryBB((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
     }
 
     @Override
@@ -42,7 +42,7 @@ public class BlockPumpkinPie extends BlockEdible
         float xMin = l >= 2 ? 0.5f : f;
         float zMin = l >= 3 ? 0.5f : f;
         float f2 = 0.4375F;
-        return AABB.getBoundingBoxFromPool((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
+        return AABB.getTemporaryBB((float) x + xMin, y, (float) z + zMin, (float)(x + 1) - f, ((float) y + f2) - f, (float)(z + 1) - f);
     }
 
 }
